import theater.*;


public class Bruecke extends Prop {
    private int anzahlSchwergewichte;
    private int anzahlLeichtgewichte;
    private int wartendeSchwergewichte;
    private boolean schreiberPrioritaet;

    Bruecke() {
        setImage("bruecke.gif");
        this.anzahlSchwergewichte = 0;
        this.anzahlLeichtgewichte = 0;
        this.wartendeSchwergewichte = 0;
        this.schreiberPrioritaet = false;
    }

    public void setLocation(int col, int row) {
        super.setLocation(400, 251);
    }

    public void setSchreiberPrioritaet(boolean on) {
        this.schreiberPrioritaet = on;
    }

    public boolean isSchreiberPrioritaet() {
        return this.schreiberPrioritaet;
    }

    synchronized void betretenSchwergewicht() {
        while ((this.anzahlSchwergewichte != 0) ||
                (this.anzahlLeichtgewichte != 0)) {
            try {
                this.wartendeSchwergewichte++;
                this.wait();
                this.wartendeSchwergewichte--;
            } catch (InterruptedException exc) {
            }
        }

        this.anzahlSchwergewichte++;
    }

    synchronized void verlassenSchwergewicht() {
        this.anzahlSchwergewichte--;
        this.notifyAll();
    }

    synchronized void betretenLeichtgewicht() {
        while ((this.anzahlSchwergewichte > 0) ||
                (this.schreiberPrioritaet && (this.wartendeSchwergewichte > 0))) {
            try {
                this.wait();
            } catch (InterruptedException exc) {
            }
        }

        this.anzahlLeichtgewichte++;
    }

    synchronized void verlassenLeichtgewicht() {
        this.anzahlLeichtgewichte--;
        this.notifyAll();
    }
}
