import theater.*;
import java.awt.event.MouseEvent;


public class Duenn extends Actor {
    private static final int MAX_COL = 260;
    private static final int ROW = 201;
    private static final int SPEED = 2;
    private boolean running = false;

    public Duenn() {
        setImage("ameise.gif");
    }

    public void run() {
        running = true;

        Bruecke bruecke = ((Landschaft) getStage()).getBruecke();
        Blume blume = ((Landschaft) getStage()).getBlume();

        while (true) {
            this.laufeZurBruecke(bruecke);
            bruecke.betretenLeichtgewicht();
            this.laufeZurBlume(blume);

            // riechen
            this.verlasseDieBruecke(bruecke);
            bruecke.verlassenLeichtgewicht();
            this.laufeZurueck();
        }
    }

    public void setLocation(int col, int row) {
        if (!running && (col > MAX_COL)) {
            col = MAX_COL;
        }

        super.setLocation(col, ROW);
    }

    void laufeZurBruecke(Bruecke bruecke) {
        while (!this.intersects(bruecke)) {
            this.setLocation(this.getColumn() + SPEED, ROW);
        }
    }

    void laufeZurBlume(Blume blume) {
        Cell mitte = new Cell(blume.getColumn(), blume.getRow());

        while (!mitte.intersects(this)) {
            this.setLocation(this.getColumn() + SPEED, ROW);
        }

        // duftende Blume gefunden
    }

    void verlasseDieBruecke(Bruecke bruecke) {
        this.getImage().mirrorHorizontally();

        while (this.intersects(bruecke)) {
            this.setLocation(this.getColumn() - SPEED, ROW);
        }
    }

    void laufeZurueck() {
        while (this.intersects(getStage())) {
            this.setLocation(this.getColumn() - SPEED, ROW);
        }

        this.getImage().mirrorHorizontally();
    }

    public void mousePressed(MouseInfo event) {
        // Veraenderung der Thread-Prioritaet bei Mausklick auf Icon
        event.consume();

        if (event.getButton() == MouseEvent.BUTTON1) {
            setPriority(Math.min(getPriority() + 1, Thread.MAX_PRIORITY));
        } else {
            setPriority(Math.max(getPriority() - 1, Thread.MIN_PRIORITY));
        }
    }
}
